(in-package :sockint)

(defconstant af-unix 1)
(defconstant af-inet 2)
(defconstant af-local af-unix)
(defconstant msg-oob 1)
(defconstant msg-peek 2)
(defconstant msg-trunc #x8000)
(defconstant msg-waitall 0)

(defconstant ip-options 1)
(defconstant so-debug 1)
(defconstant so-acceptconn 2)
(defconstant so-reuseaddr 4)
(defconstant so-keepalive 8)
(defconstant so-dontroute 16)
(defconstant so-broadcast 32)
(defconstant so-useloopback 64)
(defconstant so-linger 128)
(defconstant so-oobinline 256)
(defconstant so-dontlinger (lognot so-linger))
(defconstant so-excludiveaddruse (lognot so-reuseaddr))
(defconstant so-sndbuf #x1001)
(defconstant so-rcvbuf #x1002)
(defconstant so-sndlowat #x1003)
(defconstant so-rcvlowat #x1004)
(defconstant so-sndtimeo #x1005)
(defconstant so-rcvtimeo #x1006)
(defconstant so-error #x1007)
(defconstant so-type #x1008)

(defconstant socket-error -1)
(defconstant sock-stream 1)
(defconstant sock-dgram 2)
(defconstant sock-raw 3)
(defconstant sock-rdm 4)
(defconstant sock-seqpacket 5)
(defconstant tcp-nodelay #x0001)
(defconstant o-append #x0008)

;; some other windows error code
(defconstant ERROR_NOT_ENOUGH_MEMORY 8)

;; misc unixy error codes
(defconstant ENOMEM ERROR_NOT_ENOUGH_MEMORY)
(defconstant EPERM 1)

;; basic socket errors
(defconstant WSABASEERR 10000)
(defconstant EINTR (+ WSABASEERR 4))
(defconstant EBADF (+ WSABASEERR 9))
(defconstant EACCES (+ WSABASEERR 13))
(defconstant EFAULT (+ WSABASEERR 14))
(defconstant EINVAL (+ WSABASEERR 22))
(defconstant EMFILE (+ WSABASEERR 24))
(defconstant EWOULDBLOCK (+ WSABASEERR 35))
(defconstant EAGAIN EWOULDBLOCK)
(defconstant EINPROGRESS (+ WSABASEERR 36))
(defconstant EALREADY (+ WSABASEERR 37))
(defconstant ENOTSOCK (+ WSABASEERR 38))
(defconstant EDESTADDRREQ (+ WSABASEERR 39))
(defconstant EMSGSIZE (+ WSABASEERR 40))
(defconstant EPROTOTYPE (+ WSABASEERR 41))
(defconstant ENOPROTOOPT (+ WSABASEERR 42))
(defconstant EPROTONOSUPPORT (+ WSABASEERR 43))
(defconstant ESOCKTNOSUPPORT (+ WSABASEERR 44))
(defconstant EOPNOTSUPP (+ WSABASEERR 45))
(defconstant EPFNOSUPPORT (+ WSABASEERR 46))
(defconstant EAFNOSUPPORT (+ WSABASEERR 47))
(defconstant EADDRINUSE (+ WSABASEERR 48))
(defconstant EADDRNOTAVAIL (+ WSABASEERR 49))
(defconstant ENETDOWN (+ WSABASEERR 50))
(defconstant ENETUNREACH (+ WSABASEERR 51))
(defconstant ENETRESET (+ WSABASEERR 52))
(defconstant ECONNABORTED (+ WSABASEERR 53))
(defconstant ECONNRESET (+ WSABASEERR 54))
(defconstant ENOBUFS (+ WSABASEERR 55))
(defconstant EISCONN (+ WSABASEERR 56))
(defconstant ENOTCONN (+ WSABASEERR 57))
(defconstant ESHUTDOWN (+ WSABASEERR 58))
(defconstant ETOOMANYREFS (+ WSABASEERR 59))
(defconstant ETIMEDOUT (+ WSABASEERR 60))
(defconstant ECONNREFUSED (+ WSABASEERR 61))
(defconstant ELOOP (+ WSABASEERR 62))
(defconstant ENAMETOOLONG (+ WSABASEERR 63))
(defconstant EHOSTDOWN (+ WSABASEERR 64))
(defconstant EHOSTUNREACH (+ WSABASEERR 65))
(defconstant ENOTEMPTY (+ WSABASEERR 66))
(defconstant EPROCLIM (+ WSABASEERR 67))
(defconstant EUSERS (+ WSABASEERR 68))
(defconstant EDQUOT (+ WSABASEERR 69))
(defconstant ESTALE (+ WSABASEERR 70))
(defconstant EREMOTE (+ WSABASEERR 71))
(defconstant EDISCON (+ WSABASEERR 101))
(defconstant SYSNOTREADY (+ WSABASEERR 91))
(defconstant VERNOTSUPPORTED (+ WSABASEERR 92))
(defconstant NOTINITIALISED (+ WSABASEERR 93))
(defconstant HOST_NOT_FOUND (+ WSABASEERR 1001))
(defconstant TRY_AGAIN (+ WSABASEERR 1002))
(defconstant NO_RECOVERY (+ WSABASEERR 1003))
(defconstant NO_DATA (+ WSABASEERR 1004))
(defconstant WSAENOMORE (+ WSABASEERR 102))
(defconstant WSAECANCELLED (+ WSABASEERR 103))
(defconstant WSAEINVALIDPROCTABLE (+ WSABASEERR 104))
(defconstant WSAEINVALIDPROVIDER (+ WSABASEERR 105))
(defconstant WSAEPROVIDERFAILEDINIT (+ WSABASEERR 106))
(defconstant WSASYSCALLFAILURE (+ WSABASEERR 107))
(defconstant WSASERVICE_NOT_FOUND (+ WSABASEERR 108))
(defconstant WSATYPE_NOT_FOUND (+ WSABASEERR 109))
(defconstant WSA_E_NO_MORE (+ WSABASEERR 110))
(defconstant WSA_E_CANCELLED (+ WSABASEERR 111))
(defconstant WSAEREFUSED (+ WSABASEERR 112))
(defconstant WSA_QOS_RECEIVERS (+ WSABASEERR 1005))
(defconstant WSA_QOS_SENDERS (+ WSABASEERR 1006))
(defconstant WSA_QOS_NO_SENDERS (+ WSABASEERR 1007))
(defconstant WSA_QOS_NO_RECEIVERS (+ WSABASEERR 1008))
(defconstant WSA_QOS_REQUEST_CONFIRMED (+ WSABASEERR 1009))
(defconstant WSA_QOS_ADMISSION_FAILURE (+ WSABASEERR 1010))
(defconstant WSA_QOS_POLICY_FAILURE (+ WSABASEERR 1011))
(defconstant WSA_QOS_BAD_STYLE (+ WSABASEERR 1012))
(defconstant WSA_QOS_BAD_OBJECT (+ WSABASEERR 1013))
(defconstant WSA_QOS_TRAFFIC_CTRL_ERROR (+ WSABASEERR 1014))
(defconstant WSA_QOS_GENERIC_ERROR (+ WSABASEERR 1015))
(defconstant WSA_QOS_ESERVICETYPE (+ WSABASEERR 1016))
(defconstant WSA_QOS_EFLOWSPEC (+ WSABASEERR 1017))
(defconstant WSA_QOS_EPROVSPECBUF (+ WSABASEERR 1018))
(defconstant WSA_QOS_EFILTERSTYLE (+ WSABASEERR 1019))
(defconstant WSA_QOS_EFILTERTYPE (+ WSABASEERR 1020))
(defconstant WSA_QOS_EFILTERCOUNT (+ WSABASEERR 1021))
(defconstant WSA_QOS_EOBJLENGTH (+ WSABASEERR 1022))
(defconstant WSA_QOS_EFLOWCOUNT (+ WSABASEERR 1023))
(defconstant WSA_QOS_EUNKOWNPSOBJ (+ WSABASEERR 1024))
(defconstant WSA_QOS_EPOLICYOBJ (+ WSABASEERR 1025))
(defconstant WSA_QOS_EFLOWDESC (+ WSABASEERR 1026))
(defconstant WSA_QOS_EPSFLOWSPEC (+ WSABASEERR 1027))
(defconstant WSA_QOS_EPSFILTERSPEC (+ WSABASEERR 1028))
(defconstant WSA_QOS_ESDMODEOBJ (+ WSABASEERR 1029))
(defconstant WSA_QOS_ESHAPERATEOBJ (+ WSABASEERR 1030))
(defconstant WSA_QOS_RESERVED_PETYPE (+ WSABASEERR 1031))

(defconstant HOST-NOT-FOUND (+ WSABASEERR 1001))
(defconstant TRY-AGAIN (+ WSABASEERR 1002))
(defconstant NO-RECOVERY (+ WSABASEERR 1003))
(defconstant NO-ADDRESS NO_DATA)
(defconstant SOL-SOCKET #xffff)